Sixth batch
[git/git.git] / t / test-lib.sh
CommitLineData
c74c7203 1# Test framework for git. See t/README for usage.
e1970ce4
JH
2#
3# Copyright (c) 2005 Junio C Hamano
4#
64b90323
MS
5# This program is free software: you can redistribute it and/or modify
6# it under the terms of the GNU General Public License as published by
7# the Free Software Foundation, either version 2 of the License, or
8# (at your option) any later version.
9#
10# This program is distributed in the hope that it will be useful,
11# but WITHOUT ANY WARRANTY; without even the implied warranty of
12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13# GNU General Public License for more details.
14#
15# You should have received a copy of the GNU General Public License
16# along with this program. If not, see http://www.gnu.org/licenses/ .
e1970ce4 17
3c8f12c9
JH
18# Test the binaries we have just built. The tests are kept in
19# t/ subdirectory and are run in 'trash directory' subdirectory.
20if test -z "$TEST_DIRECTORY"
21then
22 # We allow tests to override this, in case they want to run tests
23 # outside of t/, e.g. for running tests on the test library
24 # itself.
25 TEST_DIRECTORY=$(pwd)
85176d72
FC
26else
27 # ensure that TEST_DIRECTORY is an absolute path so that it
28 # is valid even if the current working directory is changed
29 TEST_DIRECTORY=$(cd "$TEST_DIRECTORY" && pwd) || exit 1
3c8f12c9
JH
30fi
31if test -z "$TEST_OUTPUT_DIRECTORY"
32then
33 # Similarly, override this to store the test-results subdir
34 # elsewhere
35 TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
36fi
37GIT_BUILD_DIR="$TEST_DIRECTORY"/..
38
d0cc5796
JK
39# If we were built with ASAN, it may complain about leaks
40# of program-lifetime variables. Disable it by default to lower
41# the noise level. This needs to happen at the start of the script,
42# before we even do our "did we build git yet" check (since we don't
43# want that one to complain to stderr).
bf1ce904 44: ${ASAN_OPTIONS=detect_leaks=0:abort_on_error=1}
d0cc5796
JK
45export ASAN_OPTIONS
46
85b81b35
JK
47# If LSAN is in effect we _do_ want leak checking, but we still
48# want to abort so that we notice the problems.
49: ${LSAN_OPTIONS=abort_on_error=1}
50export LSAN_OPTIONS
51
8abfdf44
JS
52if test ! -f "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
53then
54 echo >&2 'error: GIT-BUILD-OPTIONS missing (has Git been built?).'
55 exit 1
56fi
57. "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
58export PERL_PATH SHELL_PATH
59
b02e7d5d
JS
60# Disallow the use of abbreviated options in the test suite by default
61if test -z "${GIT_TEST_DISALLOW_ABBREVIATED_OPTIONS}"
62then
63 GIT_TEST_DISALLOW_ABBREVIATED_OPTIONS=true
64 export GIT_TEST_DISALLOW_ABBREVIATED_OPTIONS
65fi
66
2006f0ad
RR
67################################################################
68# It appears that people try to run tests without building...
8abfdf44 69"${GIT_TEST_INSTALLED:-$GIT_BUILD_DIR}/git$X" >/dev/null
2006f0ad
RR
70if test $? != 1
71then
ed306e4e
JS
72 if test -n "$GIT_TEST_INSTALLED"
73 then
74 echo >&2 "error: there is no working Git at '$GIT_TEST_INSTALLED'"
75 else
76 echo >&2 'error: you do not seem to have built git yet.'
77 fi
2006f0ad
RR
78 exit 1
79fi
80
8cf58006
SG
81# Parse options while taking care to leave $@ intact, so we will still
82# have all the original command line options when executing the test
83# script again for '--tee' and '--verbose-log' below.
84store_arg_to=
85prev_opt=
86for opt
87do
88 if test -n "$store_arg_to"
89 then
90 eval $store_arg_to=\$opt
91 store_arg_to=
92 prev_opt=
93 continue
94 fi
95
96 case "$opt" in
97 -d|--d|--de|--deb|--debu|--debug)
98 debug=t ;;
99 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
100 immediate=t ;;
101 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
102 GIT_TEST_LONG=t; export GIT_TEST_LONG ;;
103 -r)
104 store_arg_to=run_list
105 ;;
106 --run=*)
107 run_list=${opt#--*=} ;;
108 -h|--h|--he|--hel|--help)
109 help=t ;;
110 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
111 verbose=t ;;
112 --verbose-only=*)
113 verbose_only=${opt#--*=}
114 ;;
115 -q|--q|--qu|--qui|--quie|--quiet)
116 # Ignore --quiet under a TAP::Harness. Saying how many tests
117 # passed without the ok/not ok details is always an error.
118 test -z "$HARNESS_ACTIVE" && quiet=t ;;
119 --with-dashes)
120 with_dashes=t ;;
dd167a30
JS
121 --no-bin-wrappers)
122 no_bin_wrappers=t ;;
8cf58006
SG
123 --no-color)
124 color= ;;
125 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
126 valgrind=memcheck
127 tee=t
128 ;;
129 --valgrind=*)
130 valgrind=${opt#--*=}
131 tee=t
132 ;;
133 --valgrind-only=*)
134 valgrind_only=${opt#--*=}
135 tee=t
136 ;;
137 --tee)
138 tee=t ;;
139 --root=*)
140 root=${opt#--*=} ;;
141 --chain-lint)
142 GIT_TEST_CHAIN_LINT=1 ;;
143 --no-chain-lint)
144 GIT_TEST_CHAIN_LINT=0 ;;
145 -x)
146 trace=t ;;
147 -V|--verbose-log)
148 verbose_log=t
149 tee=t
150 ;;
22231908
JS
151 --write-junit-xml)
152 write_junit_xml=t
153 ;;
fb7d1e3a
SG
154 --stress)
155 stress=t ;;
156 --stress=*)
f5457371
JS
157 echo "error: --stress does not accept an argument: '$opt'" >&2
158 echo "did you mean --stress-jobs=${opt#*=} or --stress-limit=${opt#*=}?" >&2
159 exit 1
160 ;;
161 --stress-jobs=*)
162 stress=t;
fb7d1e3a
SG
163 stress=${opt#--*=}
164 case "$stress" in
7d661e5e 165 *[!0-9]*|0*|"")
f5457371 166 echo "error: --stress-jobs=<N> requires the number of jobs to run" >&2
fb7d1e3a
SG
167 exit 1
168 ;;
169 *) # Good.
170 ;;
171 esac
172 ;;
76e27fbf 173 --stress-limit=*)
de69e6f6 174 stress=t;
76e27fbf
SG
175 stress_limit=${opt#--*=}
176 case "$stress_limit" in
7d661e5e 177 *[!0-9]*|0*|"")
76e27fbf
SG
178 echo "error: --stress-limit=<N> requires the number of repetitions" >&2
179 exit 1
180 ;;
181 *) # Good.
182 ;;
183 esac
184 ;;
8cf58006
SG
185 *)
186 echo "error: unknown test option '$opt'" >&2; exit 1 ;;
187 esac
188
189 prev_opt=$opt
190done
191if test -n "$store_arg_to"
192then
193 echo "error: $prev_opt requires an argument" >&2
194 exit 1
195fi
196
197if test -n "$valgrind_only"
198then
199 test -z "$valgrind" && valgrind=memcheck
200 test -z "$verbose" && verbose_only="$valgrind_only"
201elif test -n "$valgrind"
202then
203 test -z "$verbose_log" && verbose=t
204fi
205
fb7d1e3a
SG
206if test -n "$stress"
207then
208 verbose=t
209 trace=t
210 immediate=t
211fi
212
213TEST_STRESS_JOB_SFX="${GIT_TEST_STRESS_JOB_NR:+.stress-$GIT_TEST_STRESS_JOB_NR}"
62c379b8 214TEST_NAME="$(basename "$0" .sh)"
ffe1afe6
SG
215TEST_NUMBER="${TEST_NAME%%-*}"
216TEST_NUMBER="${TEST_NUMBER#t}"
62c379b8 217TEST_RESULTS_DIR="$TEST_OUTPUT_DIRECTORY/test-results"
fb7d1e3a
SG
218TEST_RESULTS_BASE="$TEST_RESULTS_DIR/$TEST_NAME$TEST_STRESS_JOB_SFX"
219TRASH_DIRECTORY="trash directory.$TEST_NAME$TEST_STRESS_JOB_SFX"
61f292db
SG
220test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
221case "$TRASH_DIRECTORY" in
222/*) ;; # absolute path is good
223 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
224esac
62c379b8 225
fb7d1e3a
SG
226# If --stress was passed, run this test repeatedly in several parallel loops.
227if test "$GIT_TEST_STRESS_STARTED" = "done"
228then
229 : # Don't stress test again.
230elif test -n "$stress"
231then
232 if test "$stress" != t
233 then
234 job_count=$stress
235 elif test -n "$GIT_TEST_STRESS_LOAD"
236 then
237 job_count="$GIT_TEST_STRESS_LOAD"
238 elif job_count=$(getconf _NPROCESSORS_ONLN 2>/dev/null) &&
239 test -n "$job_count"
240 then
241 job_count=$((2 * $job_count))
242 else
243 job_count=8
244 fi
245
246 mkdir -p "$TEST_RESULTS_DIR"
247 stressfail="$TEST_RESULTS_BASE.stress-failed"
248 rm -f "$stressfail"
249
250 stress_exit=0
251 trap '
252 kill $job_pids 2>/dev/null
253 wait
254 stress_exit=1
255 ' TERM INT HUP
256
257 job_pids=
258 job_nr=0
259 while test $job_nr -lt "$job_count"
260 do
261 (
262 GIT_TEST_STRESS_STARTED=done
263 GIT_TEST_STRESS_JOB_NR=$job_nr
264 export GIT_TEST_STRESS_STARTED GIT_TEST_STRESS_JOB_NR
265
266 trap '
267 kill $test_pid 2>/dev/null
268 wait
269 exit 1
270 ' TERM INT
271
76e27fbf
SG
272 cnt=1
273 while ! test -e "$stressfail" &&
274 { test -z "$stress_limit" ||
275 test $cnt -le $stress_limit ; }
fb7d1e3a
SG
276 do
277 $TEST_SHELL_PATH "$0" "$@" >"$TEST_RESULTS_BASE.stress-$job_nr.out" 2>&1 &
278 test_pid=$!
279
280 if wait $test_pid
281 then
282 printf "OK %2d.%d\n" $GIT_TEST_STRESS_JOB_NR $cnt
283 else
284 echo $GIT_TEST_STRESS_JOB_NR >>"$stressfail"
285 printf "FAIL %2d.%d\n" $GIT_TEST_STRESS_JOB_NR $cnt
286 fi
287 cnt=$(($cnt + 1))
288 done
289 ) &
290 job_pids="$job_pids $!"
291 job_nr=$(($job_nr + 1))
292 done
293
294 wait
295
296 if test -f "$stressfail"
297 then
76e27fbf 298 stress_exit=1
fb7d1e3a
SG
299 echo "Log(s) of failed test run(s):"
300 for failed_job_nr in $(sort -n "$stressfail")
301 do
302 echo "Contents of '$TEST_RESULTS_BASE.stress-$failed_job_nr.out':"
303 cat "$TEST_RESULTS_BASE.stress-$failed_job_nr.out"
304 done
305 rm -rf "$TRASH_DIRECTORY.stress-failed"
306 # Move the last one.
307 mv "$TRASH_DIRECTORY.stress-$failed_job_nr" "$TRASH_DIRECTORY.stress-failed"
308 fi
309
310 exit $stress_exit
311fi
312
4cde519f
RR
313# if --tee was passed, write the output not only to the terminal, but
314# additionally to the file test-results/$BASENAME.out, too.
8cf58006
SG
315if test "$GIT_TEST_TEE_STARTED" = "done"
316then
317 : # do not redirect again
318elif test -n "$tee"
319then
62c379b8 320 mkdir -p "$TEST_RESULTS_DIR"
452320f1
JK
321
322 # Make this filename available to the sub-process in case it is using
323 # --verbose-log.
62c379b8 324 GIT_TEST_TEE_OUTPUT_FILE=$TEST_RESULTS_BASE.out
452320f1
JK
325 export GIT_TEST_TEE_OUTPUT_FILE
326
327 # Truncate before calling "tee -a" to get rid of the results
328 # from any previous runs.
329 >"$GIT_TEST_TEE_OUTPUT_FILE"
330
3f824e91 331 (GIT_TEST_TEE_STARTED=done ${TEST_SHELL_PATH} "$0" "$@" 2>&1;
62c379b8
SG
332 echo $? >"$TEST_RESULTS_BASE.exit") | tee -a "$GIT_TEST_TEE_OUTPUT_FILE"
333 test "$(cat "$TEST_RESULTS_BASE.exit")" = 0
4cde519f 334 exit
8cf58006
SG
335fi
336
337if test -n "$trace" && test -n "$test_untraceable"
338then
339 # '-x' tracing requested, but this test script can't be reliably
340 # traced, unless it is run with a Bash version supporting
341 # BASH_XTRACEFD (introduced in Bash v4.1).
342 #
343 # Perform this version check _after_ the test script was
344 # potentially re-executed with $TEST_SHELL_PATH for '--tee' or
345 # '--verbose-log', so the right shell is checked and the
346 # warning is issued only once.
347 if test -n "$BASH_VERSION" && eval '
348 test ${BASH_VERSINFO[0]} -gt 4 || {
349 test ${BASH_VERSINFO[0]} -eq 4 &&
350 test ${BASH_VERSINFO[1]} -ge 1
351 }
352 '
353 then
354 : Executed by a Bash version supporting BASH_XTRACEFD. Good.
355 else
356 echo >&2 "warning: ignoring -x; '$0' is untraceable without BASH_XTRACEFD"
357 trace=
358 fi
359fi
360if test -n "$trace" && test -z "$verbose_log"
361then
362 verbose=t
363fi
4cde519f 364
e1970ce4 365# For repeatability, reset the environment to known value.
d5c1b7c2 366# TERM is sanitized below, after saving color control sequences.
e1970ce4 367LANG=C
899460f3 368LC_ALL=C
d9bdd39e 369PAGER=cat
e1970ce4 370TZ=UTC
d5c1b7c2 371export LANG LC_ALL PAGER TZ
8ff99e74 372EDITOR=:
6cdccfce
ÆAB
373
374# GIT_TEST_GETTEXT_POISON should not influence git commands executed
375# during initialization of test-lib and the test repo. Back it up,
376# unset and then restore after initialization is finished.
377if test -n "$GIT_TEST_GETTEXT_POISON"
378then
379 GIT_TEST_GETTEXT_POISON_ORIG=$GIT_TEST_GETTEXT_POISON
380 unset GIT_TEST_GETTEXT_POISON
381fi
382
661bfd13
SL
383# A call to "unset" with no arguments causes at least Solaris 10
384# /usr/xpg4/bin/sh and /bin/ksh to bail out. So keep the unsets
385# deriving from the command substitution clustered with the other
386# ones.
3c8f12c9 387unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
95a1d12e 388 my @env = keys %ENV;
730477f1
JL
389 my $ok = join("|", qw(
390 TRACE
391 DEBUG
730477f1
JL
392 TEST
393 .*_TEST
394 PROVE
395 VALGRIND
ac001282 396 UNZIP
edb54081 397 PERF_
e2a0ccc0 398 CURL_VERBOSE
4527aa10 399 TRACE_CURL
730477f1
JL
400 ));
401 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
95a1d12e
JN
402 print join("\n", @vars);
403')
7976e901 404unset XDG_CACHE_HOME
5adf84eb 405unset XDG_CONFIG_HOME
8bade1e1 406unset GITPERLLIB
29e55cd5
JH
407GIT_AUTHOR_EMAIL=author@example.com
408GIT_AUTHOR_NAME='A U Thor'
29e55cd5
JH
409GIT_COMMITTER_EMAIL=committer@example.com
410GIT_COMMITTER_NAME='C O Mitter'
8d0fc48f 411GIT_MERGE_VERBOSITY=5
f8246281
JH
412GIT_MERGE_AUTOEDIT=no
413export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
29e55cd5
JH
414export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
415export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
d33738d7 416export EDITOR
e1970ce4 417
124647c4
KB
418# Tests using GIT_TRACE typically don't want <timestamp> <file>:<line> output
419GIT_TRACE_BARE=1
420export GIT_TRACE_BARE
421
4cb54d0a 422check_var_migration () {
4231d1ba
JH
423 # the warnings and hints given from this helper depends
424 # on end-user settings, which will disrupt the self-test
425 # done on the test framework itself.
426 case "$GIT_TEST_FRAMEWORK_SELFTEST" in
427 t) return ;;
428 esac
429
4cb54d0a
BP
430 old_name=$1 new_name=$2
431 eval "old_isset=\${${old_name}:+isset}"
432 eval "new_isset=\${${new_name}:+isset}"
4231d1ba 433
4cb54d0a
BP
434 case "$old_isset,$new_isset" in
435 isset,)
436 echo >&2 "warning: $old_name is now $new_name"
437 echo >&2 "hint: set $new_name too during the transition period"
438 eval "$new_name=\$$old_name"
439 ;;
440 isset,isset)
441 # do this later
442 # echo >&2 "warning: $old_name is now $new_name"
443 # echo >&2 "hint: remove $old_name"
444 ;;
445 esac
446}
447
448check_var_migration GIT_FSMONITOR_TEST GIT_TEST_FSMONITOR
1f357b04 449check_var_migration TEST_GIT_INDEX_VERSION GIT_TEST_INDEX_VERSION
5765d97b 450check_var_migration GIT_FORCE_PRELOAD_TEST GIT_TEST_PRELOAD_INDEX
1f357b04
BP
451
452# Use specific version of the index file format
453if test -n "${GIT_TEST_INDEX_VERSION:+isset}"
5d9fc888 454then
1f357b04 455 GIT_INDEX_VERSION="$GIT_TEST_INDEX_VERSION"
5d9fc888
TG
456 export GIT_INDEX_VERSION
457fi
458
a731fa91
EP
459# Add libc MALLOC and MALLOC_PERTURB test
460# only if we are not executing the test with valgrind
8cf58006 461if test -n "$valgrind" ||
ee1431bf 462 test -n "$TEST_NO_MALLOC_CHECK"
1b3185fc
JH
463then
464 setup_malloc_check () {
465 : nothing
466 }
467 teardown_malloc_check () {
468 : nothing
469 }
470else
471 setup_malloc_check () {
472 MALLOC_CHECK_=3 MALLOC_PERTURB_=165
473 export MALLOC_CHECK_ MALLOC_PERTURB_
474 }
475 teardown_malloc_check () {
476 unset MALLOC_CHECK_ MALLOC_PERTURB_
477 }
478fi
a731fa91 479
886a3907
JH
480# Protect ourselves from common misconfiguration to export
481# CDPATH into the environment
482unset CDPATH
483
5565f47c 484unset GREP_OPTIONS
ac001282 485unset UNZIP
5565f47c 486
3d5c0cc9 487case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
1c0cc756 4881|2|true)
025232e8 489 GIT_TRACE=4
1c0cc756 490 ;;
6ce4e61f
CC
491esac
492
cd3c095c
JH
493# Convenience
494#
5555a2aa 495# A regexp to match 5, 35 and 40 hexdigits
cd3c095c 496_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
5555a2aa
CB
497_x35="$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
498_x40="$_x35$_x05"
cd3c095c 499
3749fde5
JH
500# Zero SHA-1
501_z40=0000000000000000000000000000000000000000
502
bd981d5f 503OID_REGEX="$_x40"
198857bf 504ZERO_OID=$_z40
f9e7d9f8 505EMPTY_TREE=4b825dc642cb6eb9a060e54bf8d69288fbee4904
378932d3 506EMPTY_BLOB=e69de29bb2d1d6434b8b29ae775ad8c2e48c5391
f9e7d9f8 507
3f4ab627
JH
508# Line feed
509LF='
510'
511
bd482d6e
DL
512# Single quote
513SQ=\'
514
a42643aa
JK
515# UTF-8 ZERO WIDTH NON-JOINER, which HFS+ ignores
516# when case-folding filenames
517u200c=$(printf '\342\200\214')
518
bd981d5f 519export _x05 _x35 _x40 _z40 LF u200c EMPTY_TREE EMPTY_BLOB ZERO_OID OID_REGEX
342e9ef2 520
e1970ce4
JH
521# Each test should start with something like this, after copyright notices:
522#
523# test_description='Description of this test...
524# This test checks if command xyzzy does the right thing...
525# '
526# . ./test-lib.sh
d5c1b7c2 527test "x$TERM" != "xdumb" && (
ca92a660
RH
528 test -t 1 &&
529 tput bold >/dev/null 2>&1 &&
530 tput setaf 1 >/dev/null 2>&1 &&
531 tput sgr0 >/dev/null 2>&1
532 ) &&
533 color=t
e1970ce4 534
ca92a660
RH
535if test -n "$color"
536then
d5c1b7c2
RH
537 # Save the color control sequences now rather than run tput
538 # each time say_color() is called. This is done for two
539 # reasons:
540 # * TERM will be changed to dumb
541 # * HOME will be changed to a temporary directory and tput
542 # might need to read ~/.terminfo from the original HOME
543 # directory to get the control sequences
544 # Note: This approach assumes the control sequences don't end
545 # in a newline for any terminal of interest (command
546 # substitutions strip trailing newlines). Given that most
547 # (all?) terminals in common use are related to ECMA-48, this
548 # shouldn't be a problem.
549 say_color_error=$(tput bold; tput setaf 1) # bold red
550 say_color_skip=$(tput setaf 4) # blue
551 say_color_warn=$(tput setaf 3) # brown/yellow
552 say_color_pass=$(tput setaf 2) # green
553 say_color_info=$(tput setaf 6) # cyan
554 say_color_reset=$(tput sgr0)
555 say_color_="" # no formatting for normal text
ca92a660 556 say_color () {
d5c1b7c2
RH
557 test -z "$1" && test -n "$quiet" && return
558 eval "say_color_color=\$say_color_$1"
ca92a660 559 shift
d5c1b7c2 560 printf "%s\\n" "$say_color_color$*$say_color_reset"
ca92a660
RH
561 }
562else
563 say_color() {
564 test -z "$1" && test -n "$quiet" && return
565 shift
566 printf "%s\n" "$*"
567 }
568fi
569
d5c1b7c2
RH
570TERM=dumb
571export TERM
572
55db1df0
PH
573error () {
574 say_color error "error: $*"
6e7b5aaf 575 GIT_EXIT_OK=t
55db1df0
PH
576 exit 1
577}
578
165293af
SG
579BUG () {
580 error >&7 "bug in the test script: $*"
581}
582
55db1df0
PH
583say () {
584 say_color info "$*"
585}
586
614fe015
JK
587if test -n "$HARNESS_ACTIVE"
588then
589 if test "$verbose" = t || test -n "$verbose_only"
590 then
591 printf 'Bail out! %s\n' \
592 'verbose mode forbidden under TAP harness; try --verbose-log'
593 exit 1
594 fi
595fi
596
570f3226
MB
597test "${test_description}" != "" ||
598error "Test script did not set test_description."
599
600if test "$help" = "t"
601then
cb1aefda 602 printf '%s\n' "$test_description"
570f3226
MB
603 exit 0
604fi
605
4d9d62fa 606exec 5>&1
781f76b1 607exec 6<&0
4ecae3c8 608exec 7>&2
452320f1
JK
609if test "$verbose_log" = "t"
610then
611 exec 3>>"$GIT_TEST_TEE_OUTPUT_FILE" 4>&3
612elif test "$verbose" = "t"
e1970ce4
JH
613then
614 exec 4>&2 3>&1
615else
616 exec 4>/dev/null 3>/dev/null
617fi
618
d88785e4
JK
619# Send any "-x" output directly to stderr to avoid polluting tests
620# which capture stderr. We can do this unconditionally since it
621# has no effect if tracing isn't turned on.
622#
623# Note that this sets up the trace fd as soon as we assign the variable, so it
624# must come after the creation of descriptor 4 above. Likewise, we must never
625# unset this, as it has the side effect of closing descriptor 4, which we
626# use to show verbose tests to the user.
627#
628# Note also that we don't need or want to export it. The tracing is local to
629# this shell, and we would not want to influence any shells we exec.
630BASH_XTRACEFD=4
631
e1970ce4
JH
632test_failure=0
633test_count=0
41ac414e
JH
634test_fixed=0
635test_broken=0
2d84e9fb 636test_success=0
e1970ce4 637
d998bd4a
ÆAB
638test_external_has_tap=0
639
faa4bc35 640die () {
6e7b5aaf 641 code=$?
900721e1
JS
642 # This is responsible for running the atexit commands even when a
643 # test script run with '--immediate' fails, or when the user hits
644 # ctrl-C, i.e. when 'test_done' is not invoked at all.
645 test_atexit_handler || code=$?
6e7b5aaf
CB
646 if test -n "$GIT_EXIT_OK"
647 then
648 exit $code
649 else
650 echo >&5 "FATAL: Unexpected exit with code $code"
651 exit 1
652 fi
faa4bc35
CB
653}
654
6e7b5aaf 655GIT_EXIT_OK=
35641310 656trap 'die' EXIT
c5c39f4e
SG
657# Disable '-x' tracing, because with some shells, notably dash, it
658# prevents running the cleanup commands when a test script run with
659# '--verbose-log -x' is interrupted.
660trap '{ code=$?; set +x; } 2>/dev/null; exit $code' INT TERM HUP
41184273 661
12a29b1a
TR
662# The user-facing functions are loaded from a separate file so that
663# test_perf subshells can have them too
3c8f12c9 664. "$TEST_DIRECTORY/test-lib-functions.sh"
05236a5e 665
886856ab 666# You are not expected to call test_ok_ and test_failure_ directly, use
3fa36666 667# the test_expect_* functions instead.
886856ab
JH
668
669test_ok_ () {
22231908
JS
670 if test -n "$write_junit_xml"
671 then
672 write_junit_xml_testcase "$*"
673 fi
d5d9de1b 674 test_success=$(($test_success + 1))
633fe50a 675 say_color "" "ok $test_count - $@"
e1970ce4
JH
676}
677
886856ab 678test_failure_ () {
22231908
JS
679 if test -n "$write_junit_xml"
680 then
681 junit_insert="<failure message=\"not ok $test_count -"
682 junit_insert="$junit_insert $(xml_attr_encode "$1")\">"
683 junit_insert="$junit_insert $(xml_attr_encode \
af9912ef
JS
684 "$(if test -n "$GIT_TEST_TEE_OUTPUT_FILE"
685 then
686 test-tool path-utils skip-n-bytes \
687 "$GIT_TEST_TEE_OUTPUT_FILE" $GIT_TEST_TEE_OFFSET
688 else
689 printf '%s\n' "$@" | sed 1d
690 fi)")"
22231908 691 junit_insert="$junit_insert</failure>"
af9912ef
JS
692 if test -n "$GIT_TEST_TEE_OUTPUT_FILE"
693 then
694 junit_insert="$junit_insert<system-err>$(xml_attr_encode \
695 "$(cat "$GIT_TEST_TEE_OUTPUT_FILE")")</system-err>"
696 fi
22231908
JS
697 write_junit_xml_testcase "$1" " $junit_insert"
698 fi
d5d9de1b 699 test_failure=$(($test_failure + 1))
633fe50a 700 say_color error "not ok $test_count - $1"
bf0dd8a8 701 shift
cb1aefda 702 printf '%s\n' "$*" | sed -e 's/^/# /'
6e7b5aaf 703 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
886856ab
JH
704}
705
41ac414e 706test_known_broken_ok_ () {
22231908
JS
707 if test -n "$write_junit_xml"
708 then
709 write_junit_xml_testcase "$* (breakage fixed)"
710 fi
41ac414e 711 test_fixed=$(($test_fixed+1))
633fe50a 712 say_color error "ok $test_count - $@ # TODO known breakage vanished"
41ac414e
JH
713}
714
715test_known_broken_failure_ () {
22231908
JS
716 if test -n "$write_junit_xml"
717 then
718 write_junit_xml_testcase "$* (known breakage)"
719 fi
41ac414e 720 test_broken=$(($test_broken+1))
633fe50a 721 say_color warn "not ok $test_count - $@ # TODO known breakage"
41ac414e 722}
886856ab
JH
723
724test_debug () {
8e832ebc 725 test "$debug" = "" || eval "$1"
e1970ce4
JH
726}
727
e6a6ddc9
TR
728match_pattern_list () {
729 arg="$1"
730 shift
731 test -z "$*" && return 1
732 for pattern_
733 do
734 case "$arg" in
735 $pattern_)
736 return 0
737 esac
738 done
739 return 1
740}
741
0445e6f0
IB
742match_test_selector_list () {
743 title="$1"
744 shift
745 arg="$1"
746 shift
747 test -z "$1" && return 0
748
749 # Both commas and whitespace are accepted as separators.
750 OLDIFS=$IFS
751 IFS=' ,'
752 set -- $1
753 IFS=$OLDIFS
754
755 # If the first selector is negative we include by default.
756 include=
757 case "$1" in
758 !*) include=t ;;
759 esac
760
761 for selector
762 do
763 orig_selector=$selector
764
765 positive=t
766 case "$selector" in
767 !*)
768 positive=
769 selector=${selector##?}
770 ;;
771 esac
772
773 test -z "$selector" && continue
774
775 case "$selector" in
776 *-*)
777 if expr "z${selector%%-*}" : "z[0-9]*[^0-9]" >/dev/null
778 then
779 echo "error: $title: invalid non-numeric in range" \
780 "start: '$orig_selector'" >&2
781 exit 1
782 fi
783 if expr "z${selector#*-}" : "z[0-9]*[^0-9]" >/dev/null
784 then
785 echo "error: $title: invalid non-numeric in range" \
786 "end: '$orig_selector'" >&2
787 exit 1
788 fi
789 ;;
790 *)
791 if expr "z$selector" : "z[0-9]*[^0-9]" >/dev/null
792 then
793 echo "error: $title: invalid non-numeric in test" \
794 "selector: '$orig_selector'" >&2
795 exit 1
796 fi
797 esac
798
799 # Short cut for "obvious" cases
800 test -z "$include" && test -z "$positive" && continue
801 test -n "$include" && test -n "$positive" && continue
802
803 case "$selector" in
804 -*)
805 if test $arg -le ${selector#-}
806 then
807 include=$positive
808 fi
809 ;;
810 *-)
811 if test $arg -ge ${selector%-}
812 then
813 include=$positive
814 fi
815 ;;
816 *-*)
817 if test ${selector%%-*} -le $arg \
818 && test $arg -le ${selector#*-}
819 then
820 include=$positive
821 fi
822 ;;
823 *)
824 if test $arg -eq $selector
825 then
826 include=$positive
827 fi
828 ;;
829 esac
830 done
831
832 test -n "$include"
833}
834
ff09af3f
TR
835maybe_teardown_verbose () {
836 test -z "$verbose_only" && return
837 exec 4>/dev/null 3>/dev/null
838 verbose=
839}
840
841last_verbose=t
842maybe_setup_verbose () {
843 test -z "$verbose_only" && return
26a07309 844 if match_pattern_list $test_count $verbose_only
ff09af3f
TR
845 then
846 exec 4>&2 3>&1
847 # Emit a delimiting blank line when going from
848 # non-verbose to verbose. Within verbose mode the
849 # delimiter is printed by test_expect_*. The choice
850 # of the initial $last_verbose is such that before
851 # test 1, we do not print it.
852 test -z "$last_verbose" && echo >&3 ""
853 verbose=t
854 else
855 exec 4>/dev/null 3>/dev/null
856 verbose=
857 fi
858 last_verbose=$verbose
859}
860
5dfc368f
TR
861maybe_teardown_valgrind () {
862 test -z "$GIT_VALGRIND" && return
863 GIT_VALGRIND_ENABLED=
864}
865
866maybe_setup_valgrind () {
867 test -z "$GIT_VALGRIND" && return
26a07309 868 if test -z "$valgrind_only"
5dfc368f
TR
869 then
870 GIT_VALGRIND_ENABLED=t
871 return
872 fi
873 GIT_VALGRIND_ENABLED=
874 if match_pattern_list $test_count $valgrind_only
875 then
876 GIT_VALGRIND_ENABLED=t
877 fi
878}
879
9b5fe78b 880want_trace () {
f5ba2de6
JK
881 test "$trace" = t && {
882 test "$verbose" = t || test "$verbose_log" = t
883 }
9b5fe78b
JK
884}
885
a136f6d8
JK
886# This is a separate function because some tests use
887# "return" to end a test_expect_success block early
888# (and we want to make sure we run any cleanup like
889# "set +x").
890test_eval_inner_ () {
891 # Do not add anything extra (including LF) after '$*'
892 eval "
9b5fe78b 893 want_trace && set -x
a136f6d8
JK
894 $*"
895}
896
a7c58f28 897test_eval_ () {
90c8a1db
JK
898 # If "-x" tracing is in effect, then we want to avoid polluting stderr
899 # with non-test commands. But once in "set -x" mode, we cannot prevent
a136f6d8
JK
900 # the shell from printing the "set +x" to turn it off (nor the saving
901 # of $? before that). But we can make sure that the output goes to
902 # /dev/null.
903 #
90c8a1db
JK
904 # There are a few subtleties here:
905 #
906 # - we have to redirect descriptor 4 in addition to 2, to cover
907 # BASH_XTRACEFD
908 #
909 # - the actual eval has to come before the redirection block (since
910 # it needs to see descriptor 4 to set up its stderr)
911 #
912 # - likewise, any error message we print must be outside the block to
913 # access descriptor 4
914 #
915 # - checking $? has to come immediately after the eval, but it must
916 # be _inside_ the block to avoid polluting the "set -x" output
917 #
918
919 test_eval_inner_ "$@" </dev/null >&3 2>&4
a136f6d8 920 {
a136f6d8 921 test_eval_ret_=$?
9b5fe78b 922 if want_trace
a136f6d8
JK
923 then
924 set +x
a136f6d8 925 fi
90c8a1db
JK
926 } 2>/dev/null 4>&2
927
928 if test "$test_eval_ret_" != 0 && want_trace
929 then
930 say_color error >&4 "error: last command exited with \$?=$test_eval_ret_"
931 fi
a136f6d8 932 return $test_eval_ret_
a7c58f28
JN
933}
934
4d9d62fa 935test_run_ () {
b6b0afdc 936 test_cleanup=:
b586744a 937 expecting_failure=$2
bb79af9d 938
92b269f5 939 if test "${GIT_TEST_CHAIN_LINT:-1}" != 0; then
2a01ef8c
JK
940 # turn off tracing for this test-eval, as it simply creates
941 # confusing noise in the "-x" output
942 trace_tmp=$trace
943 trace=
bb79af9d
JK
944 # 117 is magic because it is unlikely to match the exit
945 # code of other programs
878f9883
ES
946 if $(printf '%s\n' "$1" | sed -f "$GIT_BUILD_DIR/t/chainlint.sed" | grep -q '?![A-Z][A-Z]*?!') ||
947 test "OK-117" != "$(test_eval_ "(exit 117) && $1${LF}${LF}echo OK-\$?" 3>&1)"
99a64e4b 948 then
165293af 949 BUG "broken &&-chain or run-away HERE-DOC: $1"
bb79af9d 950 fi
2a01ef8c 951 trace=$trace_tmp
bb79af9d
JK
952 fi
953
a57397b0 954 setup_malloc_check
a7c58f28 955 test_eval_ "$1"
b6b0afdc 956 eval_ret=$?
a57397b0 957 teardown_malloc_check
b586744a 958
a136f6d8
JK
959 if test -z "$immediate" || test $eval_ret = 0 ||
960 test -n "$expecting_failure" && test "$test_cleanup" != ":"
b586744a 961 then
1b3185fc 962 setup_malloc_check
a7c58f28 963 test_eval_ "$test_cleanup"
1b3185fc 964 teardown_malloc_check
b586744a 965 fi
1c0cc756
RJ
966 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
967 then
57e1538a
ÆAB
968 echo ""
969 fi
aa0bcf96 970 return "$eval_ret"
4d9d62fa
PR
971}
972
ae75342c 973test_start_ () {
8586f98b 974 test_count=$(($test_count+1))
ff09af3f 975 maybe_setup_verbose
5dfc368f 976 maybe_setup_valgrind
22231908
JS
977 if test -n "$write_junit_xml"
978 then
979 junit_start=$(test-tool date getnanos)
980 fi
ae75342c
TR
981}
982
983test_finish_ () {
984 echo >&3 ""
5dfc368f 985 maybe_teardown_valgrind
ff09af3f 986 maybe_teardown_verbose
af9912ef
JS
987 if test -n "$GIT_TEST_TEE_OFFSET"
988 then
989 GIT_TEST_TEE_OFFSET=$(test-tool path-utils file-size \
990 "$GIT_TEST_TEE_OUTPUT_FILE")
991 fi
ae75342c
TR
992}
993
994test_skip () {
04ece593 995 to_skip=
ef2ac68d 996 skipped_reason=
e6a6ddc9
TR
997 if match_pattern_list $this_test.$test_count $GIT_SKIP_TESTS
998 then
999 to_skip=t
ef2ac68d 1000 skipped_reason="GIT_SKIP_TESTS"
e6a6ddc9 1001 fi
05236a5e
JN
1002 if test -z "$to_skip" && test -n "$test_prereq" &&
1003 ! test_have_prereq "$test_prereq"
a7bb3940
JS
1004 then
1005 to_skip=t
ef2ac68d 1006
07431fc8 1007 of_prereq=
05236a5e 1008 if test "$missing_prereq" != "$test_prereq"
07431fc8 1009 then
05236a5e 1010 of_prereq=" of $test_prereq"
07431fc8 1011 fi
ef2ac68d
IB
1012 skipped_reason="missing $missing_prereq${of_prereq}"
1013 fi
0445e6f0
IB
1014 if test -z "$to_skip" && test -n "$run_list" &&
1015 ! match_test_selector_list '--run' $test_count "$run_list"
1016 then
1017 to_skip=t
1018 skipped_reason="--run"
1019 fi
07431fc8 1020
ef2ac68d
IB
1021 case "$to_skip" in
1022 t)
22231908
JS
1023 if test -n "$write_junit_xml"
1024 then
1025 message="$(xml_attr_encode "$skipped_reason")"
1026 write_junit_xml_testcase "$1" \
1027 " <skipped message=\"$message\" />"
1028 fi
1029
633fe50a 1030 say_color skip >&3 "skipping test: $@"
ef2ac68d 1031 say_color skip "ok $test_count # skip $1 ($skipped_reason)"
04ece593
JH
1032 : true
1033 ;;
1034 *)
1035 false
1036 ;;
1037 esac
1038}
1039
342e9ef2
TR
1040# stub; perf-lib overrides it
1041test_at_end_hook_ () {
1042 :
1043}
1044
22231908
JS
1045write_junit_xml () {
1046 case "$1" in
1047 --truncate)
1048 >"$junit_xml_path"
1049 junit_have_testcase=
1050 shift
1051 ;;
1052 esac
1053 printf '%s\n' "$@" >>"$junit_xml_path"
1054}
1055
1056xml_attr_encode () {
1057 printf '%s\n' "$@" | test-tool xml-encode
1058}
1059
1060write_junit_xml_testcase () {
1061 junit_attrs="name=\"$(xml_attr_encode "$this_test.$test_count $1")\""
1062 shift
1063 junit_attrs="$junit_attrs classname=\"$this_test\""
1064 junit_attrs="$junit_attrs time=\"$(test-tool \
1065 date getnanos $junit_start)\""
1066 write_junit_xml "$(printf '%s\n' \
1067 " <testcase $junit_attrs>" "$@" " </testcase>")"
1068 junit_have_testcase=t
1069}
1070
900721e1
JS
1071test_atexit_cleanup=:
1072test_atexit_handler () {
1073 # In a succeeding test script 'test_atexit_handler' is invoked
1074 # twice: first from 'test_done', then from 'die' in the trap on
1075 # EXIT.
1076 # This condition and resetting 'test_atexit_cleanup' below makes
1077 # sure that the registered cleanup commands are run only once.
1078 test : != "$test_atexit_cleanup" || return 0
1079
1080 setup_malloc_check
1081 test_eval_ "$test_atexit_cleanup"
1082 test_atexit_cleanup=:
1083 teardown_malloc_check
1084}
1085
e1970ce4 1086test_done () {
6e7b5aaf 1087 GIT_EXIT_OK=t
2d84e9fb 1088
900721e1
JS
1089 # Run the atexit commands _before_ the trash directory is
1090 # removed, so the commands can access pidfiles and socket files.
1091 test_atexit_handler
1092
22231908
JS
1093 if test -n "$write_junit_xml" && test -n "$junit_xml_path"
1094 then
1095 test -n "$junit_have_testcase" || {
1096 junit_start=$(test-tool date getnanos)
1097 write_junit_xml_testcase "all tests skipped"
1098 }
1099
1100 # adjust the overall time
1101 junit_time=$(test-tool date getnanos $junit_suite_start)
1102 sed "s/<testsuite [^>]*/& time=\"$junit_time\"/" \
1103 <"$junit_xml_path" >"$junit_xml_path.new"
1104 mv "$junit_xml_path.new" "$junit_xml_path"
1105
1106 write_junit_xml " </testsuite>" "</testsuites>"
1107 fi
1108
1c0cc756
RJ
1109 if test -z "$HARNESS_ACTIVE"
1110 then
62c379b8 1111 mkdir -p "$TEST_RESULTS_DIR"
8ef1abe5 1112
62c379b8 1113 cat >"$TEST_RESULTS_BASE.counts" <<-EOF
c54e6be7
ML
1114 total $test_count
1115 success $test_success
1116 fixed $test_fixed
1117 broken $test_broken
1118 failed $test_failure
1119
1120 EOF
8ef1abe5 1121 fi
41ac414e
JH
1122
1123 if test "$test_fixed" != 0
1124 then
633fe50a 1125 say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
41ac414e
JH
1126 fi
1127 if test "$test_broken" != 0
1128 then
633fe50a 1129 say_color warn "# still have $test_broken known breakage(s)"
b73d9a23
AS
1130 fi
1131 if test "$test_broken" != 0 || test "$test_fixed" != 0
1132 then
1133 test_remaining=$(( $test_count - $test_broken - $test_fixed ))
1134 msg="remaining $test_remaining test(s)"
11d54b8b 1135 else
b73d9a23 1136 test_remaining=$test_count
11d54b8b 1137 msg="$test_count test(s)"
41ac414e 1138 fi
e1970ce4 1139 case "$test_failure" in
10b94e28 1140 0)
1c0cc756
RJ
1141 if test $test_external_has_tap -eq 0
1142 then
b73d9a23 1143 if test $test_remaining -gt 0
d87bd7c1 1144 then
633fe50a 1145 say_color pass "# passed all $msg"
d87bd7c1 1146 fi
c7018be5
JH
1147
1148 # Maybe print SKIP message
1149 test -z "$skip_all" || skip_all="# SKIP $skip_all"
1150 case "$test_count" in
1151 0)
1152 say "1..$test_count${skip_all:+ $skip_all}"
1153 ;;
1154 *)
1155 test -z "$skip_all" ||
1156 say_color warn "$skip_all"
1157 say "1..$test_count"
1158 ;;
1159 esac
d998bd4a 1160 fi
abc5d372 1161
06478dab 1162 if test -z "$debug"
4d0912a2 1163 then
06478dab 1164 test -d "$TRASH_DIRECTORY" ||
4d0912a2 1165 error "Tests passed but trash directory already removed before test cleanup; aborting"
abc5d372 1166
06478dab 1167 cd "$TRASH_DIRECTORY/.." &&
046e90d1
JS
1168 rm -fr "$TRASH_DIRECTORY" || {
1169 # try again in a bit
1170 sleep 5;
1171 rm -fr "$TRASH_DIRECTORY"
1172 } ||
4d0912a2 1173 error "Tests passed but test cleanup failed; aborting"
4d0912a2 1174 fi
342e9ef2
TR
1175 test_at_end_hook_
1176
e1970ce4
JH
1177 exit 0 ;;
1178
1179 *)
1c0cc756
RJ
1180 if test $test_external_has_tap -eq 0
1181 then
633fe50a
TR
1182 say_color error "# failed $test_failure among $msg"
1183 say "1..$test_count"
d998bd4a 1184 fi
5099b99d 1185
e1970ce4
JH
1186 exit 1 ;;
1187
1188 esac
1189}
1190
e4597aae 1191if test -n "$valgrind"
4e1be63c 1192then
4e1be63c
JS
1193 make_symlink () {
1194 test -h "$2" &&
1195 test "$1" = "$(readlink "$2")" || {
1196 # be super paranoid
1197 if mkdir "$2".lock
1198 then
1199 rm -f "$2" &&
1200 ln -s "$1" "$2" &&
1201 rm -r "$2".lock
1202 else
1203 while test -d "$2".lock
1204 do
1205 say "Waiting for lock on $2."
1206 sleep 1
1207 done
1208 fi
1209 }
1210 }
1211
1212 make_valgrind_symlink () {
36bfb0e5 1213 # handle only executables, unless they are shell libraries that
11d62145 1214 # need to be in the exec-path.
36bfb0e5 1215 test -x "$1" ||
2a59a6ef 1216 test "# " = "$(test_copy_bytes 2 <"$1")" ||
36bfb0e5 1217 return;
4e1be63c
JS
1218
1219 base=$(basename "$1")
28fab7b2
RS
1220 case "$base" in
1221 test-*)
1222 symlink_target="$GIT_BUILD_DIR/t/helper/$base"
1223 ;;
1224 *)
1225 symlink_target="$GIT_BUILD_DIR/$base"
1226 ;;
1227 esac
4e1be63c
JS
1228 # do not override scripts
1229 if test -x "$symlink_target" &&
1230 test ! -d "$symlink_target" &&
2a59a6ef 1231 test "#!" != "$(test_copy_bytes 2 <"$symlink_target")"
4e1be63c
JS
1232 then
1233 symlink_target=../valgrind.sh
1234 fi
efd92ffd
JS
1235 case "$base" in
1236 *.sh|*.perl)
1237 symlink_target=../unprocessed-script
1238 esac
4e1be63c
JS
1239 # create the link, or replace it if it is out of date
1240 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
1241 }
1242
26a07309
TR
1243 # override all git executables in TEST_DIRECTORY/..
1244 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
1245 mkdir -p "$GIT_VALGRIND"/bin
503e2241 1246 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/t/helper/test-*
26a07309
TR
1247 do
1248 make_valgrind_symlink $file
1249 done
1250 # special-case the mergetools loadables
1251 make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
1252 OLDIFS=$IFS
1253 IFS=:
1254 for path in $PATH
1255 do
1256 ls "$path"/git-* 2> /dev/null |
1257 while read file
ad0e6233 1258 do
26a07309 1259 make_valgrind_symlink "$file"
ad0e6233 1260 done
26a07309
TR
1261 done
1262 IFS=$OLDIFS
4e1be63c
JS
1263 PATH=$GIT_VALGRIND/bin:$PATH
1264 GIT_EXEC_PATH=$GIT_VALGRIND/bin
1265 export GIT_VALGRIND
952af351
TR
1266 GIT_VALGRIND_MODE="$valgrind"
1267 export GIT_VALGRIND_MODE
5dfc368f 1268 GIT_VALGRIND_ENABLED=t
26a07309 1269 test -n "$valgrind_only" && GIT_VALGRIND_ENABLED=
5dfc368f 1270 export GIT_VALGRIND_ENABLED
1c0cc756
RJ
1271elif test -n "$GIT_TEST_INSTALLED"
1272then
e4597aae
MO
1273 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
1274 error "Cannot run git from $GIT_TEST_INSTALLED."
16df35cb 1275 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR/t/helper:$PATH
e4597aae
MO
1276 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
1277else # normal case, use ../bin-wrappers only unless $with_dashes:
dd167a30 1278 if test -n "$no_bin_wrappers"
1c0cc756 1279 then
dd167a30
JS
1280 with_dashes=t
1281 else
1282 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
1283 if ! test -x "$git_bin_dir/git"
1c0cc756 1284 then
dd167a30
JS
1285 if test -z "$with_dashes"
1286 then
1287 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
1288 fi
1289 with_dashes=t
e4597aae 1290 fi
dd167a30 1291 PATH="$git_bin_dir:$PATH"
e4597aae 1292 fi
6cec5c68 1293 GIT_EXEC_PATH=$GIT_BUILD_DIR
1c0cc756
RJ
1294 if test -n "$with_dashes"
1295 then
ca7312d3 1296 PATH="$GIT_BUILD_DIR:$GIT_BUILD_DIR/t/helper:$PATH"
e4597aae 1297 fi
4e1be63c 1298fi
6cec5c68 1299GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
8bfa6bd6 1300GIT_CONFIG_NOSYSTEM=1
3c995beb 1301GIT_ATTR_NOSYSTEM=1
8f323c00 1302export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
49ccb087 1303
5e87eae9
JH
1304if test -z "$GIT_TEST_CMP"
1305then
1306 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
1307 then
1308 GIT_TEST_CMP="$DIFF -c"
1309 else
1310 GIT_TEST_CMP="$DIFF -u"
1311 fi
1312fi
1313
20d2a30f 1314GITPERLLIB="$GIT_BUILD_DIR"/perl/build/lib
6fcca938 1315export GITPERLLIB
6cec5c68 1316test -d "$GIT_BUILD_DIR"/templates/blt || {
eea42069
JH
1317 error "You haven't built things yet, have you?"
1318}
e1970ce4 1319
d609615f 1320if ! test -x "$GIT_BUILD_DIR"/t/helper/test-tool$X
1c0cc756 1321then
0e496492
NTND
1322 echo >&2 'You need to build test-tool:'
1323 echo >&2 'Run "make t/helper/test-tool" in the source (toplevel) directory'
56cf9806
EW
1324 exit 1
1325fi
1326
e1970ce4 1327# Test repository
38b074de 1328rm -fr "$TRASH_DIRECTORY" || {
6e7b5aaf 1329 GIT_EXIT_OK=t
8d14ac94
JH
1330 echo >&5 "FATAL: Cannot prepare test area"
1331 exit 1
1332}
1333
90cff968 1334HOME="$TRASH_DIRECTORY"
0ea47f9d
JH
1335GNUPGHOME="$HOME/gnupg-home-not-used"
1336export HOME GNUPGHOME
90cff968 1337
1c0cc756
RJ
1338if test -z "$TEST_NO_CREATE_REPO"
1339then
38b074de 1340 test_create_repo "$TRASH_DIRECTORY"
342e9ef2 1341else
38b074de 1342 mkdir -p "$TRASH_DIRECTORY"
342e9ef2 1343fi
22231908 1344
1bd9c648
LW
1345# Use -P to resolve symlinks in our working directory so that the cwd
1346# in subprocesses like git equals our $PWD (for pathname comparisons).
38b074de 1347cd -P "$TRASH_DIRECTORY" || exit 1
04ece593 1348
d5d9de1b
JS
1349this_test=${0##*/}
1350this_test=${this_test%%-*}
e6a6ddc9
TR
1351if match_pattern_list "$this_test" $GIT_SKIP_TESTS
1352then
1353 say_color info >&3 "skipping test $this_test altogether"
1354 skip_all="skip all tests in $this_test"
1355 test_done
1356fi
f17e9fbb 1357
22231908
JS
1358if test -n "$write_junit_xml"
1359then
1360 junit_xml_dir="$TEST_OUTPUT_DIRECTORY/out"
1361 mkdir -p "$junit_xml_dir"
1362 junit_xml_base=${0##*/}
1363 junit_xml_path="$junit_xml_dir/TEST-${junit_xml_base%.sh}.xml"
1364 junit_attrs="name=\"${junit_xml_base%.sh}\""
1365 junit_attrs="$junit_attrs timestamp=\"$(TZ=UTC \
1366 date +%Y-%m-%dT%H:%M:%S)\""
1367 write_junit_xml --truncate "<testsuites>" " <testsuite $junit_attrs>"
1368 junit_suite_start=$(test-tool date getnanos)
af9912ef
JS
1369 if test -n "$GIT_TEST_TEE_OUTPUT_FILE"
1370 then
1371 GIT_TEST_TEE_OFFSET=0
1372 fi
22231908
JS
1373fi
1374
11f470ae
JH
1375# Provide an implementation of the 'yes' utility; the upper bound
1376# limit is there to help Windows that cannot stop this loop from
1377# wasting cycles when the downstream stops reading, so do not be
1378# tempted to turn it into an infinite loop. cf. 6129c930 ("test-lib:
1379# limit the output of the yes utility", 2016-02-02)
8648732e
BC
1380yes () {
1381 if test $# = 0
1382 then
1383 y=y
1384 else
1385 y="$*"
1386 fi
1387
6129c930
JS
1388 i=0
1389 while test $i -lt 99
8648732e 1390 do
6129c930
JS
1391 echo "$y"
1392 i=$(($i+1))
8648732e
BC
1393 done
1394}
1395
c7400399
ÆAB
1396# The GIT_TEST_FAIL_PREREQS code hooks into test_set_prereq(), and
1397# thus needs to be set up really early, and set an internal variable
1398# for convenience so the hot test_set_prereq() codepath doesn't need
1399# to call "git env--helper". Only do that work if needed by seeing if
1400# GIT_TEST_FAIL_PREREQS is set at all.
1401GIT_TEST_FAIL_PREREQS_INTERNAL=
1402if test -n "$GIT_TEST_FAIL_PREREQS"
1403then
1404 if git env--helper --type=bool --default=0 --exit-code GIT_TEST_FAIL_PREREQS
1405 then
1406 GIT_TEST_FAIL_PREREQS_INTERNAL=true
1407 test_set_prereq FAIL_PREREQS
1408 fi
1409else
1410 test_lazy_prereq FAIL_PREREQS '
1411 git env--helper --type=bool --default=0 --exit-code GIT_TEST_FAIL_PREREQS
1412 '
1413fi
1414
f17e9fbb 1415# Fix some commands on Windows
d98b2c5f
JS
1416uname_s=$(uname -s)
1417case $uname_s in
f17e9fbb
JS
1418*MINGW*)
1419 # Windows has its own (incompatible) sort and find
1420 sort () {
1421 /usr/bin/sort "$@"
1422 }
1423 find () {
1424 /usr/bin/find "$@"
1425 }
4114156a
JS
1426 # git sees Windows-style pwd
1427 pwd () {
1428 builtin pwd -W
1429 }
ee9fb68c 1430 # no POSIX permissions
6fd1106a 1431 # backslashes in pathspec are converted to '/'
fb9a2bea 1432 # exec does not inherit the PID
a94114ad 1433 test_set_prereq MINGW
5f4e02e5 1434 test_set_prereq NATIVE_CRLF
a31d0665 1435 test_set_prereq SED_STRIPS_CR
97669eed 1436 test_set_prereq GREP_STRIPS_CR
4d715ac0 1437 GIT_TEST_CMP=mingw_test_cmp
a31d0665
RJ
1438 ;;
1439*CYGWIN*)
1440 test_set_prereq POSIXPERM
a31d0665 1441 test_set_prereq EXECKEEPSPID
cfa96496 1442 test_set_prereq CYGWIN
a31d0665 1443 test_set_prereq SED_STRIPS_CR
97669eed 1444 test_set_prereq GREP_STRIPS_CR
ee9fb68c
JS
1445 ;;
1446*)
1447 test_set_prereq POSIXPERM
6fd1106a 1448 test_set_prereq BSLASHPSPEC
fb9a2bea 1449 test_set_prereq EXECKEEPSPID
f17e9fbb
JS
1450 ;;
1451esac
704a3143 1452
b082687c 1453( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
1b19ccd2 1454test -z "$NO_PERL" && test_set_prereq PERL
68c7d276 1455test -z "$NO_PTHREADS" && test_set_prereq PTHREADS
d4e1b47a 1456test -z "$NO_PYTHON" && test_set_prereq PYTHON
94da9193 1457test -n "$USE_LIBPCRE1$USE_LIBPCRE2" && test_set_prereq PCRE
ce9a2570
ÆAB
1458test -n "$USE_LIBPCRE1" && test_set_prereq LIBPCRE1
1459test -n "$USE_LIBPCRE2" && test_set_prereq LIBPCRE2
5e9637c6 1460test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
1b19ccd2 1461
6cdccfce
ÆAB
1462if test -n "$GIT_TEST_GETTEXT_POISON_ORIG"
1463then
1464 GIT_TEST_GETTEXT_POISON=$GIT_TEST_GETTEXT_POISON_ORIG
f88b9cb6 1465 export GIT_TEST_GETTEXT_POISON
6cdccfce
ÆAB
1466 unset GIT_TEST_GETTEXT_POISON_ORIG
1467fi
1468
1ff750b1
ÆAB
1469test_lazy_prereq C_LOCALE_OUTPUT '
1470 ! git env--helper --type=bool --default=0 --exit-code GIT_TEST_GETTEXT_POISON
1471'
bb946bba 1472
4592e608
NTND
1473if test -z "$GIT_TEST_CHECK_CACHE_TREE"
1474then
1475 GIT_TEST_CHECK_CACHE_TREE=true
1476 export GIT_TEST_CHECK_CACHE_TREE
1477fi
1478
20073274
AS
1479test_lazy_prereq PIPE '
1480 # test whether the filesystem supports FIFOs
7b7bea23
RJ
1481 test_have_prereq !MINGW,!CYGWIN &&
1482 rm -f testfifo && mkfifo testfifo
20073274
AS
1483'
1484
04083f27
JH
1485test_lazy_prereq SYMLINKS '
1486 # test whether the filesystem supports symbolic links
1487 ln -s x y && test -h y
1488'
c91cfd19 1489
b018c735
JN
1490test_lazy_prereq FILEMODE '
1491 test "$(git config --bool core.filemode)" = true
1492'
1493
ac39aa61
MG
1494test_lazy_prereq CASE_INSENSITIVE_FS '
1495 echo good >CamelCase &&
1496 echo bad >camelcase &&
1497 test "$(cat CamelCase)" != good
1498'
1499
6ec63305
WC
1500test_lazy_prereq FUNNYNAMES '
1501 test_have_prereq !MINGW &&
1502 touch -- \
1503 "FUNNYNAMES tab embedded" \
1504 "FUNNYNAMES \"quote embedded\"" \
1505 "FUNNYNAMES newline
1506embedded" 2>/dev/null &&
1507 rm -- \
1508 "FUNNYNAMES tab embedded" \
1509 "FUNNYNAMES \"quote embedded\"" \
1510 "FUNNYNAMES newline
1511embedded" 2>/dev/null
1512'
1513
5b0b5dd4
MG
1514test_lazy_prereq UTF8_NFD_TO_NFC '
1515 # check whether FS converts nfd unicode to nfc
1516 auml=$(printf "\303\244")
1517 aumlcdiar=$(printf "\141\314\210")
1518 >"$auml" &&
742ae10e 1519 test -f "$aumlcdiar"
5b0b5dd4
MG
1520'
1521
09feffb6
JK
1522test_lazy_prereq AUTOIDENT '
1523 sane_unset GIT_AUTHOR_NAME &&
1524 sane_unset GIT_AUTHOR_EMAIL &&
1525 git var GIT_AUTHOR_IDENT
1526'
1527
6219bb22
JH
1528test_lazy_prereq EXPENSIVE '
1529 test -n "$GIT_TEST_LONG"
1530'
1531
5b1fe6eb
ÆAB
1532test_lazy_prereq EXPENSIVE_ON_WINDOWS '
1533 test_have_prereq EXPENSIVE || test_have_prereq !MINGW,!CYGWIN
1534'
1535
e1ecd9e3
JH
1536test_lazy_prereq USR_BIN_TIME '
1537 test -x /usr/bin/time
1538'
1539
1767c517
JK
1540test_lazy_prereq NOT_ROOT '
1541 uid=$(id -u) &&
1542 test "$uid" != 0
1543'
1544
63b747ce 1545test_lazy_prereq JGIT '
abd0f289 1546 jgit --version
63b747ce
JT
1547'
1548
719c3da2
JH
1549# SANITY is about "can you correctly predict what the filesystem would
1550# do by only looking at the permission bits of the files and
1551# directories?" A typical example of !SANITY is running the test
1552# suite as root, where a test may expect "chmod -r file && cat file"
1553# to fail because file is supposed to be unreadable after a successful
1554# chmod. In an environment (i.e. combination of what filesystem is
1555# being used and who is running the tests) that lacks SANITY, you may
1556# be able to delete or create a file when the containing directory
1557# doesn't have write permissions, or access a file even if the
1558# containing directory doesn't have read or execute permissions.
1559
f400e51c
TB
1560test_lazy_prereq SANITY '
1561 mkdir SANETESTD.1 SANETESTD.2 &&
1562
1563 chmod +w SANETESTD.1 SANETESTD.2 &&
1564 >SANETESTD.1/x 2>SANETESTD.2/x &&
1565 chmod -w SANETESTD.1 &&
719c3da2 1566 chmod -r SANETESTD.1/x &&
f400e51c 1567 chmod -rx SANETESTD.2 ||
165293af 1568 BUG "cannot prepare SANETESTD"
f400e51c 1569
719c3da2 1570 ! test -r SANETESTD.1/x &&
f400e51c
TB
1571 ! rm SANETESTD.1/x && ! test -f SANETESTD.2/x
1572 status=$?
1573
1574 chmod +rwx SANETESTD.1 SANETESTD.2 &&
1575 rm -rf SANETESTD.1 SANETESTD.2 ||
165293af 1576 BUG "cannot clean SANETESTD"
f400e51c
TB
1577 return $status
1578'
f838ce58 1579
d98b2c5f 1580test FreeBSD != $uname_s || GIT_UNZIP=${GIT_UNZIP:-/usr/local/bin/unzip}
f838ce58
JK
1581GIT_UNZIP=${GIT_UNZIP:-unzip}
1582test_lazy_prereq UNZIP '
1583 "$GIT_UNZIP" -v
1584 test $? -ne 127
1585'
9a308de3
JK
1586
1587run_with_limited_cmdline () {
1588 (ulimit -s 128 && "$@")
1589}
1590
21dac1de
RJ
1591test_lazy_prereq CMDLINE_LIMIT '
1592 test_have_prereq !MINGW,!CYGWIN &&
1593 run_with_limited_cmdline true
1594'
6b9c38e1 1595
4db464f8
MG
1596run_with_limited_stack () {
1597 (ulimit -s 128 && "$@")
1598}
1599
21dac1de
RJ
1600test_lazy_prereq ULIMIT_STACK_SIZE '
1601 test_have_prereq !MINGW,!CYGWIN &&
1602 run_with_limited_stack true
1603'
4db464f8 1604
6b9c38e1
JK
1605build_option () {
1606 git version --build-options |
1607 sed -ne "s/^$1: //p"
1608}
1609
1610test_lazy_prereq LONG_IS_64BIT '
1611 test 8 -le "$(build_option sizeof-long)"
1612'
a07fb050 1613
a801a7cf
NTND
1614test_lazy_prereq TIME_IS_64BIT 'test-tool date is64bit'
1615test_lazy_prereq TIME_T_IS_64BIT 'test-tool date time_t-is64bit'
e9184b07
JK
1616
1617test_lazy_prereq CURL '
1618 curl --version
1619'
d16ab634 1620
1621# SHA1 is a test if the hash algorithm in use is SHA-1. This is both for tests
1622# which will not work with other hash algorithms and tests that work but don't
1623# test anything meaningful (e.g. special values which cause short collisions).
1624test_lazy_prereq SHA1 '
1625 test $(git hash-object /dev/null) = e69de29bb2d1d6434b8b29ae775ad8c2e48c5391
1626'
11aad464
JS
1627
1628test_lazy_prereq REBASE_P '
1629 test -z "$GIT_TEST_SKIP_REBASE_P"
1630'